<script setup lang="ts">
import { useMemberStore } from '@/stores/member';
import type { Member } from '@/types/Member';
import { nextTick, onMounted, ref } from 'vue';
import type { VForm } from 'vuetify/components';

const usemember = useMemberStore()
const members = ref<Member[]>([
  { id: 1, name: 'Vernon Chwe', tel: '0656728778' },
  { id: 2, name: 'Joshua Hong', tel: '0903964877' },
  { id: 3, name: 'Mingyu Kim', tel: '0947954484' },
  { id: 4, name: 'Manfah', tel: '0889739169' },
  { id: 5, name: 'paewnosuke', tel: '0994239334' }])

const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },

  { title: 'Actions', key: 'actions', sortable: false }]

function initialize() {
  members.value = [{ id: 1, name: 'Vernon Chwe', tel: '0656728778' },
  { id: 2, name: 'Joshua Hong', tel: '0903964877' },
  { id: 3, name: 'Mingyu Kim', tel: '0947954484' },
  { id: 4, name: 'Manfah', tel: '0889739169' },
  { id: 5, name: 'paewnosuke', tel: '0994239334' }]
}
onMounted(() => {
  initialize()
})
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initialUser: Member = {
  id: -1,
  name: '',
  tel: '',

}
const editedUser = ref<Member>(JSON.parse(JSON.stringify(initialUser)))
let editedIndex = -1
let lastId = 6
function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initialUser)
  })
}
function deleteItemConfirm() {
  members.value.splice(editedIndex, 1)
  closeDelete()
}
function deleteItem(item: Member) {
  editedIndex = members.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialogDelete.value = true
  //editedIndex = -1
}
function editItem(item: Member) {
  editedIndex = members.value.indexOf(item)
  editedUser.value = Object.assign({}, item)
  dialog.value = true
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedUser.value = Object.assign({}, initialUser)
    editedIndex = -1
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(members.value[editedIndex], editedUser.value)
  } else {
    editedUser.value.id = lastId++
    members.value.push(editedUser.value)
  }
  editedIndex = -1
  closeDialog()
}
</script>

<template>
   <div style="margin-bottom: 12%;"> <v-data-table :headers="headers" :items="members">
        <template v-slot:top>
      <v-toolbar flat style="background-color: rgb(97, 63, 45, 0.867);">
        <v-toolbar-title style="color: whitesmoke;">Member</v-toolbar-title>
        <v-divider
          class="mx-4"
          inset
          vertical
        ></v-divider>
        <v-spacer></v-spacer>
        
        
    <v-dialog
      v-model="dialog"
      persistent
      width="1024"
    >
      <template v-slot:activator="{ props }">
        <v-btn
        style="background-color: rgb(216, 201, 201); width: 150px; height: 45px" class="mr-4"
          color="black"
          v-bind="props"
        >
          New Member
        </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">Member info</span>
        </v-card-title>
        <v-card-text>
            <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                    <v-row>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.name"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Name"
                              ></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                            <v-text-field
                            v-model="editedUser.tel"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            class="mb-2"
                            clearable
                            label="Tel"
                              ></v-text-field>
                        </v-col>
                        
                      
                    </v-row>
                
                </v-container>

      </v-form>
          <small>*indicates required field</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-darken-1" variant="text" @click="closeDialog()" style="color: red;">Close</v-btn>
          <v-btn color="blue-darken-1" variant="text" @click="save()">Save</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  
        <!-- Delete Dialog -->
        <v-dialog v-model="dialogDelete" max-width="500px">
          <v-card>
            <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
        </template>
        <template v-slot:[`item.actions`]="{ item }">
      <v-icon
        size="small"
        class="me-2"
        color="blue-darken-1"
        @click="editItem(item)"
      >
        mdi-pencil
      </v-icon>
      <v-icon
        size="small"
        color="red-accent-4"
        @click="deleteItem(item)"
      >
        mdi-delete
      </v-icon>
    </template>
    <template v-slot:no-data>
      <v-btn
        color="primary"
        @click="initialize"
      >
        Reset
      </v-btn>
    </template>
        </v-data-table>
    </div>
</template>
